- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# CBC_CTS_Encryption Class Reference

Inheritance diagram for CBC_CTS_Encryption:

List of all members.

## Detailed Description

Definition at line 217 of file modes.h.

## Public Member Functions
void | SetStolenIV (byte *iv)
unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| for ciphers where the last block of data is special, encrypt or decrypt the last block of data
void | ProcessBlocks (byte *outString, const byte *inString, size_t numberOfBlocks)
IV_Requirement | IVRequirement () const
| returns the minimal requirement for secure IVs
bool | RequireAlignedInput () const
unsigned int | MandatoryBlockSize () const
| returns block size, if input must be processed in blocks, otherwise 1
bool | IsRandomAccess () const
| returns whether this cipher supports random access
bool | IsSelfInverting () const
| returns whether this transformation is self-inverting (e.g. xor with a keystream)
bool | IsForwardTransformation () const
| returns whether this is an encryption object
void | Resynchronize (const byte *iv)
| resynchronize with an IV
void | ProcessData (byte *outString, const byte *inString, size_t length)
| encrypt or decrypt an array of bytes of specified length
size_t | MinKeyLength () const
| returns smallest valid key length in bytes */
size_t | MaxKeyLength () const
| returns largest valid key length in bytes */
size_t | DefaultKeyLength () const
| returns default (recommended) key length in bytes */
size_t | GetValidKeyLength (size_t n) const
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
bool | IsValidKeyLength (size_t n) const
| returns whether n is a valid key length
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
unsigned int | IVSize () const
| returns size of IVs used by this object
void | GetNextIV (byte *IV)
| get a secure IV for the next message
## Static Public Member Functions
static const char *__cdecl | StaticAlgorithmName ()
## Protected Member Functions
void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
void | ResizeBuffers ()
unsigned int | BlockSize () const
virtual void | SetFeedbackSize (unsigned int feedbackSize)
## Protected Attributes
byte * | m_stolenIV
SecByteBlock | m_buffer
BlockCipher * | m_cipher
SecByteBlock | m_register

## Member Function Documentation

void CBC_CTS_Encryption::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length |
| ) |  |  | `[virtual]`

for ciphers where the last block of data is special, encrypt or decrypt the last block of data

For now the only use of this function is for CBC-CTS mode.

Reimplemented from StreamTransformation.

Definition at line 157 of file modes.cpp.

References CipherModeBase::BlockSize(), CipherModeBase::m_cipher, CipherModeBase::m_register, and m_stolenIV.

void BlockOrientedCipherModeBase::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length |
| ) |  |  | `[virtual, inherited]`

encrypt or decrypt an array of bytes of specified length

Note:
  either inString == outString, or they don't overlap

Implements StreamTransformation.

Definition at line 108 of file modes.cpp.

References CipherModeBase::BlockSize(), BlockOrientedCipherModeBase::m_buffer, CipherModeBase::m_cipher, and BlockOrientedCipherModeBase::RequireAlignedInput().

void CipherModeBase::GetNextIV | ( | byte * | IV | ) | `[virtual, inherited]`

get a secure IV for the next message

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects.

Reimplemented from SimpleKeyingInterface.

Definition at line 27 of file modes.cpp.

References CipherModeBase::BlockSize(), StreamTransformation::IsForwardTransformation(), CipherModeBase::m_cipher, and CipherModeBase::m_register.

The documentation for this class was generated from the following files:

- modes.h
- modes.cpp